//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------
texture 	g_texture;
float4		g_offset;


//--------------------------------------------------------------------------------------
// Texture samplers
//--------------------------------------------------------------------------------------
sampler TextureSampler = 
sampler_state
{
    Texture = <g_texture>;
	MipFilter = NONE;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU =Clamp;
	AddressV =Clamp;
};	


//--------------------------------------------------------------------------------------
// Vertex shader
//--------------------------------------------------------------------------------------
void BasicVS( float4 in_pos : POSITION0,
 			  float2 in_tex : TEXCOORD0,
 			  out float4 out_pos : POSITION0,
 			  out float2 out_tex : TEXCOORD0)
{
	out_pos = in_pos;
	out_tex = in_tex;
}

//--------------------------------------------------------------------------------------
// Pixel shader
//--------------------------------------------------------------------------------------
void BasicPS( float2 in_tex : TEXCOORD0,
 			  out float4 out_color : COLOR0)
{
	in_tex.x = in_tex.x + g_offset.x; 
	in_tex.y = in_tex.y + g_offset.y; 
	out_color = tex2D(TextureSampler, in_tex);
}

//--------------------------------------------------------------------------------------
// Pixel shader
//--------------------------------------------------------------------------------------
technique BasicTech
{
    pass P0
    {
        vertexShader = compile vs_3_0 BasicVS();
        pixelShader  = compile ps_3_0 BasicPS();
        
        ZENABLE = FALSE;
        ZWRITEENABLE = FALSE;
	}
    pass P1
    {
        vertexShader = compile vs_3_0 BasicVS();
        pixelShader  = compile ps_3_0 BasicPS();
        
        ZFUNC = GREATER;
	}
	
	pass P2
    {
        vertexShader = compile vs_3_0 BasicVS();
        pixelShader  = compile ps_3_0 BasicPS();
        
        ZENABLE = FALSE;
        ZWRITEENABLE = FALSE;
        ALPHABLENDENABLE = TRUE;
        SRCBLEND = ONE;
        DESTBLEND = ONE;
	}
}
