//------------------------------------------------
// O[oϐ
//------------------------------------------------
float4x4 	g_world;
float4x4 	g_world_inv;
float4x4 	g_view;
float4x4 	g_proj;
float4		g_color0;
float4		g_color1;
float4		g_light_dir;
texture		g_texture;

float		c_Density;
float4		c_Color;

texture		g_texture_env;


//------------------------------------------------
// eNX`Tv
//------------------------------------------------
sampler TextureSampler = 
sampler_state
{
    Texture = <g_texture>;
	MipFilter = NONE;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU =Clamp;
	AddressV =Clamp;
};	

sampler EnvTextureSampler = 
sampler_state
{
    Texture = <g_texture_env>;
	MipFilter = NONE;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU =Clamp;
	AddressV =Clamp;
};	


//------------------------------------------------
// _VF[_
//------------------------------------------------
void BasicVS( 	float3 in_pos : POSITION,
				float3 in_normal : NORMAL,
				float2 in_tex : TEXCOORD0,
 				out float4 out_pos : POSITION,
  				out float4 out_color :COLOR0,
 				out float2 out_tex : TEXCOORD0,
				out float3 out_pos_v : TEXCOORD1,
 				out float3 out_normal : NORMAL)
{
	// Wϊ
	float4 world_pos;
	float4 view_pos;
	world_pos = mul(float4(in_pos, 1.0f), g_world);
	view_pos = mul(world_pos, g_view);
	out_pos = mul(view_pos, g_proj);

	// eNX`W
	out_tex = in_tex;
	
	// _Ƃ̐F̌vZ
	float4 local_light;
	local_light =  normalize( mul(g_light_dir, g_world_inv));
	out_color = saturate(g_color0 + g_color1 * max(0, dot(local_light, in_normal)));
	
	// J猩_̈ʒu
	out_pos_v = view_pos;
	
	
	// J猩@̌vZ
	float4 normal_pos;
	normal_pos = float4(in_pos + in_normal, 1.0f);
	normal_pos = mul(normal_pos, g_world);
	normal_pos = mul(normal_pos, g_view);
	out_normal = normalize(normal_pos.xyz - view_pos.xyz);


}

//------------------------------------------------
// sNZVF[_
//------------------------------------------------
void BasicPS( float4 in_color : COLOR0,
 			  float2 in_tex : TEXCOORD0,
 			  float3 in_pos_v : TEXCOORD1,
  			  float3 in_normal : NORMAL,
			  out float4 out_color : COLOR0,
			  uniform bool b_tex)
{
	

	// ˃xNg߂
	float3 reflect_vec = normalize(reflect(in_pos_v, in_normal));
	
	// }bvւ̃ANZX
	float2 env_uv;
	float4 env_color;	

	env_uv.x = reflect_vec.x;
	env_uv.y = reflect_vec.y;
	env_uv = 0.5 * env_uv + float2(0.5, 0.5);
	env_uv.y = c_Density - env_uv.y;
	env_color =  tex2D(EnvTextureSampler, env_uv);

	// ʂ̃eNX`摜̎擾
	if(b_tex){
		out_color = in_color * tex2D(TextureSampler, in_tex);
	}
	else{
		out_color = in_color;
	}

	// F̍킹
	out_color = saturate(c_Color.x * env_color + c_Color.y * out_color);

}

//------------------------------------------------
// eNjbN錾
//------------------------------------------------
technique BasicTech
{
    pass P0
    {
        vertexShader = compile vs_3_0 BasicVS();
        pixelShader  = compile ps_3_0 BasicPS(true);
        
	}
    pass P1
    {
        vertexShader = compile vs_3_0 BasicVS();
        pixelShader  = compile ps_3_0 BasicPS(false);
	}

}
